#ifndef FENETRE_H_INCLUDED
#define FENETRE_H_INCLUDED

#include <iostream>
#include <SDL/SDL.h>
#undef main
#include <ctime>
#include "Input.h"
#include "Ogre.h"
#include "Menestrel.h"
#include "Niveau.h"
#include "Fantome.h"
#include "Menu/menu.h"
/**
  fenetre adapt a des cases de 30x30 pixels


  */
enum TypeConnexion {HOST, CLIENT, LOCAL};

class Fenetre
{
public:
    Fenetre();
    ~Fenetre();

    bool init();
    void jeuhost();
    void jeuclient();
    void jeulocal();
    bool chargerNiveau(std::string nomNiveau);
    void viderFantomes();
    void fin();

private:
    SDL_Surface *m_ecran, *m_vies, *m_grosBourin;
    SDL_Rect m_posPersos, m_posFantomes;
    Input m_input;
    TypeConnexion typeCo;

    Niveau m_terrain;
    Ogre m_ogre;
    Menestrel m_menestrel;
    std::vector<Fantome*> m_fantomes;
};

#endif // FENETRE_H_INCLUDED
