#ifndef BOUTON_H_INCLUDED
#define BOUTON_H_INCLUDED

///Modifié le: 02/10/2013
///Objet: calculer renvoie un bool
///à faire:

#include <iostream>
#include <string>
#include <SDL/SDL.h>
#undef main

/*
===La classe Bouton===
    +Définition:
        Elle permet de savoir si on clique dessus. On peut l'afficher, on calcule en lui donnant les
        coordonnées de la souris, et une fonction retourne si ça a été cliqué ou pas ! Voilà le travail. ;)
        Il peut également changer de forme si on passe la souris dessus...
    +Méthodes:
        - Constructeur:

        - attribuerImg:
            Permet de donner une surface qui s'affiche quand la souris passe dessus.
            Argument: SDL_surface de la deuxième image affichable.

        - calculer:

        - afficher:

        - estClique:
            Lorsqu'un clic se déclenche, permet de savoir si l'icone est cliquée.

*/

class Bouton
{
    public:
    Bouton(SDL_Surface *objetImg, SDL_Surface *screen, int const x, int const y);
    ~Bouton();
    void attribuerImg(SDL_Surface *selectImg);
    bool calculer(int const xSouris, int const ySouris);
    void afficher();
    bool estClique(int const xSouris, int const ySouris);

    protected:
    //Attributs standards
    int m_x;
    int m_y;

    //Attributs SDL
    SDL_Surface *m_screen;
    SDL_Surface *m_objetImg;
    SDL_Surface *m_selectImg;

    SDL_Surface *m_blitImg;
};

#endif // BOUTON_H_INCLUDED
